typedef volatile unsigned int* port16;
typedef volatile unsigned char* port8;
#define inportAdress 0x600
#define outportAdress 0x400
#define inport *((port8) inportAdress)
#define outport *((port8) outportAdress)

#define lightPort *((port16) outportAdress)
#define inport1 *((port8) inportAdress)
#define inport2 *((port8) (inportAdress + 1))

#define ERROR_CODE	0x5D

unsigned char SegCodes[] = {0x77, 0x22, 0x5B, 0x6B, 0x2E, 0x6D, 0x7D, 0x23, 
			    0x7F, 0x6F, 0x3F, 0x7C, 0x55, 0x7A, 0x5D, 0x18};
			    
void DisplayNBCD ( void ) {
	char a;
	while (1) {
		a = inport;
		if ((a & 0x0F) > 9) {
			outport = ERROR_CODE;
		} else {
			outport = SegCodes[a & 0x0F];
		}		
	}
}

void CondRunDiode ( void ) {
	unsigned int lightValue = 1;
	while (1) {
		if (inport1 > inport2) {
			lightValue >>= 1;
			if (lightValue == 0) {
				lightValue = 0x8000;
			}
		} else {
			lightValue <<= 1;
			if (lightValue == 0) {
				lightValue = 1;
			}	
		}	
		lightPort = lightValue;
	}
}
			    
int main( void ) {
	int a = inport;
	CondRunDiode();
	return 0;
}

