#include <math.h>
#include "newton.h"

//Hittar ett nollställe för f i närheten av x. fprime ska vara
//derivatan av f. fprime(x) får inte returnera 0. findZero
//returnerar ett x sådant att  f(x) är i itervallet [-eps,eps]
double findZero(doublefunc f, doublefunc fprime, double x, double eps) {
    //Newton-Rapphsons metod. Iterera tills felet är mindre än eps
    while (fabs(f(x)) > eps) {
        
        x = x - f(x) / fprime(x);
    }  
    return x;
}